account/urls.py
from django.urls import path
from . import views


urlpatterns = [
    path('signup/', views.sign_up, name='signup'),
    path('signin/', views.signin, name='signin'),
    path('profile/', views.profile, name='profile'),
    path('logout/', views.log_out, name='logout'),
    path('<int:uid>/', views.account_detail, name='account_detail'),
]

ood_project/urls.py
from django.contrib import admin
from django.urls import path, include
from django.shortcuts import redirect
from django.conf import settings
from django.conf.urls.static import static


def redirect_to_signin(request):
    if request.user.is_authenticated:
        return redirect('orders_list')
    return redirect('signin')


urlpatterns = [
    path('admin/', admin.site.urls),
    path('account/', include('account.urls')),
    path('customer/', include('customer.urls')),
    path('expert/', include('expert.urls')),
    path('order/', include('order.urls')),
    path('feedback/', include('feedback.urls')),
    path('', redirect_to_signin, name='main'),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

order/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('list/', views.orders_list, name='orders_list'),
    path('<int:oid>/', views.single_order, name='single_order'),
    path('done_orders/', views.done_orders, name='done_orders'),
]

account/models.py
from django.db import models
from django.contrib.auth.models import AbstractUser


class User(AbstractUser):
    GENDER_MALE = 'male'
    GENDER_FEMALE = 'female'
    GENDER_TYPES = (
        (GENDER_MALE, GENDER_MALE),
        (GENDER_FEMALE, GENDER_FEMALE),
    )

    national_id = models.CharField(
        max_length=11,
        unique=True,
        verbose_name='کد ملی'
    )

    gender = models.CharField(
        max_length=6,
        choices=GENDER_TYPES,
        verbose_name='جنسیت'
    )

    phone_number = models.CharField(
        max_length=11,
        unique=True,
        verbose_name='شماره تلفن'
    )

    avatar = models.ImageField(
        null=True,
        blank=True,
        upload_to='profile_pics',
        default='profile_pics/default.jpeg'
    )

    @staticmethod
    def get_form_fields():
        return ['username', 'email', 'first_name', 'last_name', 'phone_number', 'national_id', 'gender']

    @property
    def is_expert(self):
        from expert.models import Expert
        return Expert.objects.filter(user=self).exists()

    @property
    def is_customer(self):
        from customer.models import Customer
        return Customer.objects.filter(user=self).exists()

account/forms.py
from django.contrib.auth.forms import UserCreationForm
from django import forms

from .models import User


class AccountCreationForm(UserCreationForm):
    class Meta:
        model = User
        fields = User.get_form_fields()


class AccountChangeForm(forms.ModelForm):
    class Meta:
        model = User
        fields = ['phone_number', 'first_name', 'last_name', 'email', 'avatar']

account/views/account_detail.py
from django.db.models import Q
from django.shortcuts import render

from account.models import User
from order.models import Order
from feedback.models import Feedback


def account_detail(request, uid):
    orders = Order.objects.filter(Q(expert__user_id=uid) | Q(customer__user_id=uid), status=Order.STATUS_DONE)
    reviews = Feedback.objects.filter(
        type=Feedback.REVIEW_TYPE, order__in=orders
    ).exclude(user_id=uid)
    rates = list(reviews.values_list('rate', flat=True))
    context = {
        'account': User.objects.get(id=uid),
        'rate': f'{sum(rates) / len(rates)}/5' if reviews else 'امتیازی برای کاربر ثبت نشده است',
        'orders_count': orders.count(),
        'reviews': reviews
    }
    return render(request, 'account_detail.html', context)

account/views/logout.py
from django.contrib.auth import logout
from django.shortcuts import redirect


def log_out(request):
    logout(request)
    return redirect('signin')

account/views/profile.py
from django.shortcuts import render

from ..forms import AccountChangeForm


def profile(request):
    if request.method == "POST":
        form = AccountChangeForm(request.POST, request.FILES, instance=request.user)
        if form.is_valid():
            form.save()
    else:
        form = AccountChangeForm(instance=request.user)
    context = {'title': 'Profile', 'form': form}
    print(context)
    return render(request, 'profile.html', context)

account/views/sign_in.py
from django.contrib.auth import authenticate, login
from django.shortcuts import render, redirect
from django.contrib.auth.forms import AuthenticationForm


def signin(request):
    form = None
    if request.method == 'POST':
        form = AuthenticationForm(request, data=request.POST)
        form.full_clean()
        username = request.POST.get('username')
        password = request.POST.get('password')
        print(password)
        user = authenticate(request, username=username, password=password)
        if user is not None:
            login(request, user)
            if user.is_customer:
                return redirect('profile')
            elif user.is_expert:
                return redirect('skills')
    errors = []
    if form:
        for e in form.errors.values():
            errors.extend(e)
    context = {'title': 'Log in', 'errors': errors}
    return render(request, 'login.html', context)

account/views/sign_up.py
from django.shortcuts import render, redirect

from customer.models import Customer
from expert.models import Expert
from ..forms import AccountCreationForm


def sign_up(request):
    if request.method == "POST":
        form = AccountCreationForm(request.POST)
        if form.is_valid():
            is_customer = request.POST.get('type')
            user = form.save()
            if is_customer == '1':
                Customer.objects.create(user=user)
            else:
                Expert.objects.create(user=user)
            return redirect('signin')
    else:
        form = AccountCreationForm()
    errors = []
    for e in form.errors.values():
        errors.extend(e)
    print(form.data)
    context = {'title': 'Sign up', 'form': form, 'errors': errors}
    return render(request, 'register.html', context)

account/templates/account_detail.html
{% extends "base.html" %}
{% block header %}
    <style>
        .m-card-item {
            padding: 20px 0;
            display: flex;
            justify-content: space-between;
            align-items: center;
        }

        .m-card-item:not(:last-child) {
            border-bottom: 1px solid rgba(225, 227, 229, 1);
        }

        .m-card {
            margin-bottom: 24px;
            width: 100%;
        }

        .m-review-box > div:not(:first-child) {
            padding: 8px 24px;
        }
    </style>
{% endblock header %}
{% block title %}
    پروفایل {{ account.first_name }} {{ account.last_name }}
{% endblock %}
{% block body_title %}
    پروفایل {{ account.first_name }} {{ account.last_name }}
{% endblock %}
{% block content %}
    <div class="ui middle aligned center aligned grid">
        <div class="column">
            <img style="width: 200px; height: 200px; border: 1px solid; border-radius: 50%;"
                 src="/media/{{ account.avatar }}" alt="avatar">
            <div class="m-card" style="padding: 0 20px; margin: 0 auto;">
                <div class="m-card-item">
                    <div>
                        <span>شماره تماس</span>
                    </div>
                    <div>
                        <span>{{ account.phone_number }}</span>
                    </div>
                </div>
                <div class="m-card-item">
                    <div>
                        <span>تعداد سفارشات</span>
                    </div>
                    <div>
                        <span>{{ orders_count }}</span>
                    </div>
                </div>
                <div class="m-card-item">
                    <div>
                        <span>امتیاز</span>
                    </div>
                    <div>
                        {% if rate == '1' %}
                            <a class="ui red label">{{ rate }}</a>
                        {% elif rate < '4' %}
                            <a class="ui yellow label">{{ rate }}</a>
                        {% else %}
                            <a class="ui green label">{{ rate }}</a>
                        {% endif %}
                    </div>
                </div>
            </div>
        </div>
    </div>
    {% if reviews.count %}
        <div class="body-header" style="margin-top: 24px;">
            <span>
                نظرات کاربران
            </span>
        </div>
        {% for review in reviews %}
            <div class="m-card m-review-box" style="width: 50%; margin: 8px auto;">
                <div>
                    <span>
                        {{ review.user.first_name }} {{ review.user.last_name }}
                    </span>
                    <span>برای</span>
                    <span>
                        {{ review.order.expertise.name }}
                    </span>
                </div>
                <div class="ui divider"></div>
                <div>
                    <span>امتیاز:</span>
                    {% if review.rate == 1 %}
                        <a class="ui red label">{{ review.rate }}</a>
                    {% elif review.rate < 4 %}
                        <a class="ui yellow label">{{ review.rate }}</a>
                    {% else %}
                        <a class="ui green label">{{ review.rate }}</a>
                    {% endif %}
                </div>
                <div>
                    <span>توضیح:</span>
                    <span style="color: gray;">{{ review.content }}</span>
                </div>
            </div>
        {% endfor %}
    {% endif %}
{% endblock %}

account/templates/login.html
{% extends "base.html" %}
{% block header %}
    <style>

    </style>
{% endblock header %}
{% block title %}
    ورود
{% endblock %}
{% block body_title %}
    ورود
{% endblock %}
{% block content %}
    <div class="ui middle aligned center aligned grid">
        <div class="column">
            <div class="m-description">
                <span>
                    وارد اکانت خود شوید
                </span>
            </div>
            <form action="/account/signin/" method="POST" class="ui large form">
                {% csrf_token %}
                {% for error in errors %}
                    <div class="m-error">
                        <span>
                            {{ error }}
                        </span>
                    </div>
                {% endfor %}
                <div class="m-card">
                    <div class="field">
                        <div class="ui right icon input">
                            <i class="user icon"></i>
                            <input type="text" name="username" placeholder="نام کاربری">
                        </div>
                    </div>
                    <div class="field">
                        <div class="ui right icon input">
                            <i class="lock icon"></i>
                            <input type="password" name="password" placeholder="رمز عبور">
                        </div>
                    </div>
                    <button type="submit" class="ui submit button fluid m-primary-button">
                        ورود
                    </button>
                </div>
            </form>
            <div class="m-message">
                اکانت نداری؟ <a href="/account/signup">ثبت‌نام کن</a>
            </div>
        </div>
    </div>
{% endblock content %}

account/templates/profile.html
{% extends 'base.html' %}
{% block title %}پروفایل{% endblock title %}
{% block body_title %}{% endblock body_title %}
{% block content %}
    <div class="ui middle aligned center aligned grid">
        <div class="column">
            <img style="width: 200px; height: 200px; border: 1px solid; border-radius: 50%;" src="/media/{{ user.avatar }}" alt="avatar">
            <form action="/account/profile/" method="POST" class="ui form" enctype="multipart/form-data">
                {% csrf_token %}
                <div class="ui hidden divider"></div>
                <h1 class="ui dividing header">اطلاعات کاربری</h1>
                <div class="field">
                    <label>نام و نام خانوادگی</label>
                    <div class="two fields">
                        <div class="field">
                            <input type="text" value="{{ user.first_name }}" name="first_name" placeholder="نام">
                        </div>
                        <div class="field">
                            <input type="text" name="last_name" value="{{ user.last_name }}"
                                   placeholder="نام‌ خانوادگی">
                        </div>
                    </div>
                </div>
                <div class="two fields">
                    <div class="field">
                        <label for="id_phone_number">شماره تماس</label>
                        <input type="text" name="phone_number" value="{{ user.phone_number }}" maxlength="10" required=""
                               id="id_phone_number">
                    </div>
                    <div class="field">
                        <label for="id_email">پست الکترونیک</label>
                        <input type="email" name="email" value="{{ user.email }}" maxlength="254" id="id_email">
                    </div>
                </div>
                <p>
                    <label for="id_avatar">آواتار</label>
                    <input type="file" name="avatar" accept="image/*" id="id_avatar">
                </p>
                <div class="ui hidden divider"></div>
                {{ form.errors }}
                <div class="ui hidden divider"></div>
                <input class="fluid ui button m-primary-button" type="submit" value="ذخیره">
            </form>
        </div>
    </div>
{% endblock content %}

account/templates/register.html
{% extends 'base.html' %}
{% block header %}
    <style>
        .m-description > span {
            color: #b2b2b2;
        }

        .m-card {
            padding: 20px;
            background-color: white;
            border-radius: 5px;
            margin-top: 8px;
            box-shadow: 0 0 0 1px rgb(63 63 68 / 5%), 0 1px 3px 0 rgb(63 63 68 / 15%);
        }
    </style>
{% endblock header %}
{% block title %}
    ثبت‌ نام
{% endblock %}
{% block body_title %}
    ثبت نام
{% endblock %}
{% block content %}
    <div class="ui middle aligned center aligned grid">
        <div class="column">
            <div class="m-description">
                <span>
                    اطلاعات خود را وارد کنید
                </span>
            </div>
            <form action="/account/signup/" method="POST" class="ui large form">
                {% csrf_token %}
                {% for error in errors %}
                    <div class="m-error">
                        <span>
                            {{ error }}
                        </span>
                    </div>
                {% endfor %}
                <div class="m-card">
                    <div class="field">
                        <label>اطلاعات کاربری</label>
                        <div class="two fields">
                            <div class="field">
                                <input type="text" value="{{ form.data.username }}" name="username" maxlength="150" autofocus="" required=""
                                       id="id_username" placeholder="نام کاربری"></div>
                            <div class="field">
                                <input type="email" value="{{ form.data.email }}" name="email" maxlength="254" id="id_email"
                                       placeholder="پست الکترونیک">
                            </div>
                        </div>
                    </div>
                    <div class="field">
                        <label>نام و نام خانوادگی</label>
                        <div class="two fields">
                            <div class="field">
                                <input type="text" value="{{ form.data.first_name }}" name="first_name" placeholder="نام">
                            </div>
                            <div class="field">
                                <input type="text" value="{{ form.data.last_name }}" name="last_name" placeholder="نام‌ خانوادگی">
                            </div>
                        </div>
                    </div>
                    <div class="two fields">
                        <div class="field">
                            <label for="id_phone_number">شماره تماس</label>
                            <input type="text" placeholder="مثال: ۰۹۱۲۳۴۵۶۷۸۹" name="phone_number" maxlength="11"
                                   required="" id="id_phone_number" pattern="[0]{1}[0-9]{10}" value="{{ form.data.phone_number }}">
                        </div>
                        <div class="field">
                            <label for="id_national_id">کد ملی</label>
                            <input type="text" name="national_id" maxlength="11" required=""
                                   id="id_national_id" value="{{ form.data.national_id }}">
                        </div>
                    </div>
                    <div class="two fields">
                        <div class="field">
                            <label for="id_gender">جنسیت</label>
                            <select name="gender" required="" id="id_gender">
                                <option value="male">آقا</option>
                                <option value="female">خانم</option>
                            </select>
                        </div>
                        <div class="field">
                            <label>نوع</label>
                            <select name="type" class="ui dropdown">
                                <option value="">-</option>
                                <option value="1">مشتری</option>
                                <option value="0">متخصص</option>
                            </select>
                        </div>
                    </div>
                    <p>
                        <label for="id_password1">رمز عبور</label>
                        <input type="password" name="password1" autocomplete="new-password" required=""
                               id="id_password1">
                        <span class="helptext"></span>
                    </p>
                    <p>
                        <label for="id_password2">تکرار رمز عبور</label>
                        <input type="password" name="password2" autocomplete="new-password" required=""
                               id="id_password2">
                        <br>
                        <small>
                            رمز شما باید حاوی اعداد، حروف کوچک و بزرگ انگلیسی و علامت‌های خاص مانند @ ، _ و بیشتر از ۸
                            کاراکتر باشد
                        </small>
                        <br>
                    </p>
                    <button type="submit" class="ui submit button fluid m-primary-button">
                        ثبت‌نام
                    </button>
                </div>
            </form>
        </div>
    </div>
{% endblock content %}